#ifndef util_h
#define util_h

#include <cv.h>

// Add two points together
inline CvPoint2D32f operator+(const CvPoint2D32f& ptsA, const CvPoint2D32f& ptsB)
{
	return cvPoint2D32f(ptsA.x + ptsB.x, ptsA.y + ptsB.y);
}

// Subtract two points from each other
inline CvPoint2D32f operator-(const CvPoint2D32f& ptsA, const CvPoint2D32f& ptsB)
{
	return cvPoint2D32f(ptsA.x - ptsB.x, ptsA.y - ptsB.y);
}

// Multiply point by constant factor
inline CvPoint2D32f operator*(const CvPoint2D32f& ptsA, float f)
{
	return cvPoint2D32f(ptsA.x*f, ptsA.y*f);
}

// Calculate the determinate of matrix made up of, row 'a b' followed by row 'c d'
inline float det(float a, float b, float c, float d)
{
	return a*d - b*c;
}


void ShowResults(const IplImage * frame1, const IplImage * frame2, CvMat * warp );

float length(const CvPoint2D32f& v);

CvPoint2D32f applyAffine(const CvMat * xform, CvPoint2D32f pt);

void PrintMatrix(const CvMat * mat);

#endif
